angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope, $ionicModal, $timeout, $http, $window, $location) {

  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  //$scope.$on('$ionicView.enter', function(e) {
  //});

  // ----
  // --- The all mighty Init
  $scope.init = function(){
     //try to get email
    var tryUser = window.localStorage.getItem("username");
    if(tryUser){
      $scope.loginData = {'username': tryUser, 'password': ''};
    }
    else{
      $scope.loginData = {};
    }
    var test1  = window.localStorage.getItem("fullTsList");
    var testDict = JSON.parse(test1);
    $scope.fullTsList = testDict;
    var pIdX = window.localStorage.getItem("pIdX");
    if(pIdX){
      $scope.pIdX = pIdX;
      $scope.loadSchedule()
    }
    $scope.isLoggedIn = false;
    if(tryUser && $scope.fullTsList){
       $scope.isLoggedIn = true;
    }
    //$scope.baseUri = "//gunnleif.com:8001";
    $scope.baseUri = 'https://signup.icelandairmidatlantic.com/magicmixRest';
    $scope.booth = "A22";
    $scope.init2();
  }
  
  
  $scope.loadSchedule = function(type){
   //console.log("loadSchedule called");
   if(!$scope.pIdX || $scope.pIdX == ""){
     return ;
   }
  
    var rand101 = '&rand101=' + Math.random();
    var uri = $scope.baseUri +  "/MeetingTimeslot/fetchCompanies?pidx=" + $scope.pIdX + rand101; 
    $http.get(uri).then( function successCallback (response) {
      //console.log(response);
      $scope.pInfo = response.data;
      $scope.fullTsList = response.data.tsInfo.fullTsList;
      var ts = $scope.parseFullTsList(response.data.tsInfo.fullTsList);
      var tsStr = JSON.stringify(ts);
      window.localStorage.setItem('fullTsList', tsStr);
    });
    //console.log("done");
   }

   $scope.parseFullTsList = function(inp){
     var res = []
     for(var i = 0; i < inp.length; ++i){
       if(inp[i].state == "accepted"){
         res.push({'timeslot' : inp[i].timeslot
                   , 'cId'    : inp[i].cId
                   , 'booth'    : inp[i].booth
                   , 'company': inp[i].company
                   , 'person' : inp[i].person});
       }
     }
     return res;
   }

  // Create the login modal that we will use later
  $ionicModal.fromTemplateUrl('templates/login.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  // Triggered in the login modal to close it
  $scope.closeLogin = function() {
    $scope.modal.hide();
  };

  // Open the login modal
  $scope.login = function() {
    $scope.modal.show();
  }; 
   $scope.logout = function() {
    $scope.isLoggedIn = false;
    //$scope.participants = [];
    //window.localStorage.removeItem("fullTsList")
  };


  // Perform the login action when the user submits the login form
  $scope.doLogin = function() {
   
    var rand101 = '?rand101=' + Math.random();
    var uri = $scope.baseUri +  "/MeetingTimeslot/authAppLogin" +  rand101;
    uri += "&username="+$scope.loginData.username;
    uri += "&password="+$scope.loginData.password;
    var success = false; 
    $http.get(uri).then( function successCallback (response) {
      //console.log("response %o", response);
      $scope.pidx = response.data;
      if(response.data.result == "success"){
        success = true;
        $scope.pIdX = response.data.pIdX;
        window.localStorage.setItem("username",$scope.loginData.username);
        $scope.isLoggedIn = true;
        $scope.loadSchedule();
      }
      else{
        $scope.isLoggedIn = false;
      }  
    
      
    });


    //console.log('Doing login', $scope.loginData);

    // Simulate a login delay. Remove this and replace with your login
    // code if using a login system
    $timeout(function() {
      $scope.closeLogin();
    }, 2000);
  };


$scope.selectCompany = function(c){
  $scope.selecedCId = c.cId;
  var hits = false;
  for(i = 0; i < $scope.participants.length; ++i){
     if(c.cId == $scope.participants[i].myId){
       $scope.selecedCompany = $scope.participants[i];
       hit = true;
       break;
     } 
  }
  if(true){
    $location.path('/app/companyDetails');

  }
}
$scope.selectCompany2 = function(c){
  $scope.selecedCompany = c ;
  $location.path('/app/companyDetails');
}
  
  
  //$scope.init();
  //$scope.loadSchedule();
// +-+- })



// --
// --- Playlists controller
//
// +-+- .controller('ParticipantsCtrl', function($scope, $http, $window, $location, $stateParams) {
  
  $scope.getParticipants = function(){
    //$scope.baseUri = "//gunnleif.com:8001";
   $scope.baseUri = 'https://signup.icelandairmidatlantic.com/magicmixRest';  
    var rand101 = '?rand101=' + Math.random();
    var uri = $scope.baseUri +  "/MeetingTimeslot/fetchAvailableCompanies" +  rand101; 
    //console.log("init function uri: "  + uri);
    //console.log("pidx function uri: "  + $scope.pIdX);
    $http.get(uri).then( function successCallback (response) {
      //console.log(response);
      $scope.participants = response.data;
      //$scope.loading = true;
      $scope.ready = true;
      attSer = JSON.stringify($scope.participants);
      window.localStorage.setItem("attendies", attSer);
    });

  }

  $scope.init2 = function(type){
    $scope.ready = false;
    attSer = window.localStorage.getItem("attendies");
    $scope.participants = JSON.parse(attSer);
    if($scope.participants && $scope.participants.length > 0){
      $scope.ready = true;
    }
    $scope.getParticipants();

  }

  $scope.companyDetailsGoBack = function(){
    window.history.back();
  }  
  $scope.init();
  $scope.loadSchedule();


})

.controller('CompanyDetailsCtrl', function($scope) {
  console.log("init companyDetails controller");
$scope.todo = function(){
  console.log("haha");
}

 $scope.init = function (){
   console.log("init company details");

 }
 $scope.init();
})


.controller('ScheduleCtrl', function($scope, $stateParams) {
  //console.log("init playlist controller");
});